
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>利用SoftReference实现图片异步加载 / iVAN</title>

    <meta name="description" content="利用SoftReference实现图片异步加载 //以下是mars讲解的软引用 对象存在与堆中,对象的引用存在于栈中 比如: Object obj=new Object()//obj在栈中 obj=null 当堆内存中的对象没有任何引用指向时,垃圾回收机制会回收此块内存.即当obj=null时. 软引用: 可以保证垃圾回收机制,但是同时这个引用指向块堆里的内存.所以叫软引用. 调用 Object obj=sr.get()时,假若这个对象已经被回收那么get()方法将会返回null 可以采用MAP作为缓存.缓存里存放的是键值对,键是图片的url">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">利用SoftReference实现图片异步加载</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>//以下是mars讲解的软引用<br />
对象存在与堆中,对象的引用存在于栈中<br />
比如:<br />
Object obj=new Object()//obj在栈中<br />
obj=null<br />
当堆内存中的对象没有任何引用指向时,垃圾回收机制会回收此块内存.即当obj=null时.</p>
<p>软引用：<br />
可以保证垃圾回收机制,但是同时这个引用指向块堆里的内存.所以叫软引用.<br />
调用 Object obj=sr.get()时,假若这个对象已经被回收那么get()方法将会返回null<br />
可以采用MAP作为缓存.缓存里存放的是键值对,键是图片的url,值是这张图片对象的软引用<br />
当图片不在缓存里时才去网络上获取,若在直接从缓存里获取.<br />
提醒：网络权限&lt;uses-permission android:name="android.permission.INTERNET"/&gt; <br />
//以上是mars讲解的软引用</p>
<p>//以下是网络文章关于软引用的讲解<br />
//参考资料<br /><a href="http://blog.csdn.net/helixiuqqq/article/details/6610199" rel="external nofollow noreferrer">http://blog.csdn.net/helixiuqqq/article/details/6610199</a><br /><a href="http://blog.csdn.net/qeqeqe236/article/details/7289119" rel="external nofollow noreferrer">http://blog.csdn.net/qeqeqe236/article/details/7289119</a><br /><a href="http://blog.csdn.net/shang_515/article/details/7020027" rel="external nofollow noreferrer">http://blog.csdn.net/shang_515/article/details/7020027</a><br /><a href="http://blog.csdn.net/lvron/article/details/6721230" rel="external nofollow noreferrer">http://blog.csdn.net/lvron/article/details/6721230</a><br /><a href="http://blog.csdn.net/sgl870927/article/details/6285535" rel="external nofollow noreferrer">http://blog.csdn.net/sgl870927/article/details/6285535</a></p>
<p>如果一个对象只具有软引用,则内存空间足够,垃圾回收器就不会回收它；如果内存空间不足了,就会回收这些对象的内存.只要垃圾回收器没有回收它,该对象就可以被程序使用.软引用可用来实现内存敏感的高速缓存.</p>
<p>为什么需要使用软引用?</p>
<p>首先,我们看一个雇员信息查询系统的实例.我们将使用一个Java语言实现的雇员信息查询系统查询存储在磁盘文件或者数据库中的雇员人事档案信息.作为一个用户,我们完全有可能需要回头去查看几分钟甚至几秒钟前查看过的雇员档案信息(同样,我们在浏览WEB页面的时候也经常会使用“后退”按钮).这时我们通常会有两种程序实现方式:一种是把过去查看过的雇员信息保存在内存中,每一个存储了雇员档案信息的Java对象的生命周期贯穿整个应用程序始终;另一种是当用户开始查看其他雇员的档案信息的时候,把存储了当前所查看的雇员档案信息的Java对象结束引用,使得垃圾收集线程可以回收其所占用的内存空间,当用户再次需要浏览该雇员的档案信息的时候,重新构建该雇员的信息.很显然,第一种实现方法将造成大量的内存浪费,而第二种实现的缺陷在于即使垃圾收集线程还没有进行垃圾收集,包含雇员档案信息的对象仍然完好地保存在内存中,应用程序也要重新构建一个对象.我们知道,访问磁盘文件、访问网络资源、查询数据库等操作都是影响应用程序执行性能的重要因素,如果能重新获取那些尚未被回收的Java对象的引用,必将减少不必要的访问,大大提高程序的运行速度.</p>
<p>如何使用软引用?</p>
<p>SoftReference的特点是它的一个实例保存对一个Java对象的软引用,该软引用的存在不妨碍垃圾收集线程对该Java对象的回收.也就是说,一旦SoftReference保存了对一个Java对象的软引用后,在垃圾线程对这个Java对象回收前,SoftReference类所提供的get()方法返回Java对象的强引用.另外,一旦垃圾线程回收该Java对象之后,get()方法将返回null.</p>
<p>//以上是网络文章关于软引用的讲解</p>
<pre>以下为实例代码
//main.xml如下
&lt;?xml version="1.0" encoding="utf-8"?&gt;
&lt;ScrollView xmlns:android="http://schemas.android.com/apk/res/android"
    android:id="@+id/scrollview"
    android:layout_width="fill_parent"
    android:layout_height="wrap_content" &gt;
    &lt;LinearLayout
        xmlns:android="http://schemas.android.com/apk/res/android"
        android:layout_width="fill_parent"
        android:layout_height="fill_parent"
        android:orientation="vertical" &gt;
        &lt;TextView
            android:layout_width="fill_parent"
            android:layout_height="wrap_content"
            android:text="@string/hello" /&gt;
        &lt;ImageView
            android:id="@+id/imageView1"
            android:layout_width="wrap_content"
            android:layout_height="wrap_content" /&gt;
        &lt;ImageView
            android:id="@+id/imageView2"
            android:layout_width="wrap_content"
            android:layout_height="wrap_content" /&gt;
        &lt;ImageView
            android:id="@+id/imageView3"
            android:layout_width="wrap_content"
            android:layout_height="wrap_content" /&gt;
        &lt;ImageView
            android:id="@+id/imageView4"
            android:layout_width="wrap_content"
            android:layout_height="wrap_content" /&gt;
        &lt;ImageView
            android:id="@+id/imageView5"
            android:layout_width="wrap_content"
            android:layout_height="wrap_content" /&gt;
    &lt;/LinearLayout&gt;
&lt;/ScrollView&gt;

//Activity如下
package cn.com;
import android.app.Activity;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.widget.ImageView;
public class SoftReferenceImageLoaderActivity extends Activity {
    AsyncImageLoader asyncImageLoader=new AsyncImageLoader();
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        loadImages("http://photocdn.sohu.com/20120523/Img343875294.jpg", R.id.imageView1);
        loadImages("http://photocdn.sohu.com/20120523/Img343866809.jpg", R.id.imageView2);
        loadImages("http://photocdn.sohu.com/20120523/Img343875296.jpg", R.id.imageView3);
        loadImages("http://photocdn.sohu.com/20120523/Img343875299.jpg", R.id.imageView4);
        loadImages("http://photocdn.sohu.com/20120523/Img343875302.jpg", R.id.imageView5);
    }

    private void loadImages(String imageUrl,int imageViewID){
    	ImageView imageView=(ImageView) findViewById(imageViewID);
    	ImageCallbackImpl imageCallbackImpl=new ImageCallbackImpl(imageView);
    	//异步加载图片
    	//分析：
    	//1 如果图片在缓存中,那么我们在调用loadImages()时,在该方法的第一个if判断时就返回了
    	//  一个Drawable对象,当然其不为空.所以我们此处直接执行：
    	//  if(loadPicture!=null){
    	//	      imageView.setImageDrawable(loadPicture);
    	//  }
    	//2 若图片不在缓存中那么就需要从网络下载.
    	// 请注意：loadImages()方法中的Handle+Thread一个异步机制,这个时候返回的是null!!!!!!!!!!!
    	// 所以不会执行：
    	//  if(loadPicture!=null){
    	//	      imageView.setImageDrawable(loadPicture);
    	//  }
    	// 但是不要紧因为我们在方法loadImages()中执行了imageCallbackImpl.showLoadedImage(drawable);
    	// 也达到了目的
    	// 所以这个回调是设计得很巧妙的!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    	Drawable loadPicture=asyncImageLoader.loadImages(imageUrl, imageCallbackImpl);
    	if(loadPicture!=null){
    		imageView.setImageDrawable(loadPicture);
    	}
    }
}

//核心类如下
package cn.com;
import java.io.IOException;
import java.lang.ref.SoftReference;
import java.net.URL;
import java.util.HashMap;
import java.util.Map;
import android.graphics.drawable.Drawable;
import android.os.Handler;
import android.os.Message;
public class AsyncImageLoader {
	//Map&lt;String, SoftReference&lt;Drawable&gt;&gt;利用了Map来实现图片缓存！！！
	//键是图片的URL，值是一个SoftReference对象,该对象是一个引用指向一个Drawable对象!!!!!!!!!!!!!
	//当然这个值不是一个真正的图片,只是图片对象的引用.否则 内存很容易就满了
	private Map&lt;String,SoftReference&lt;Drawable&gt;&gt; imageCatch=new HashMap&lt;String, SoftReference&lt;Drawable&gt;&gt;();

	//回调接口.图片加载完成后会执行此方法进行显示
	public interface ImageCallback{
		public void showLoadedImage(Drawable imageDrawable);
	}

	//根据图片的URL,从网络上下载图片,并生成一个Drawable对象返回
	private Drawable loadImageFromURL(String imageURL){
		try {
			return Drawable.createFromStream(new URL(imageURL).openStream(), "src");
		} catch (IOException e) {
			e.printStackTrace();
		}
		return null;
	}
	//以下为核心代码
	public Drawable loadImages(final String imageUrl,final ImageCallback imageCallbackImpl){
		if(imageCatch.containsKey(imageUrl)){//如果图片还在缓存中
			SoftReference&lt;Drawable&gt; softReference=imageCatch.get(imageUrl);
			if(softReference!=null){//软引用还在
				return softReference.get();//返回软引用指向的对象.此时loadImages()方法结束
			}
		}
		//这也是匿名内部类的一种写法！！！！
		//如果不在缓存中,就该如下操作:
		final Handler handler=new Handler(){
			@Override
			public void handleMessage(Message msg) {
				super.handleMessage(msg);
				Drawable drawable=(Drawable) msg.obj;
				//因为内部类访问外部变量所以参数imageUrl和imageCallback要有final修饰
				//在Activity里面ImageCallbackImpl imageCallbackImpl=new ImageCallbackImpl(imageView);
				//然后在调用loadImages()方法时,将其作为参数传递给了过来.
				imageCallbackImpl.showLoadedImage(drawable);
			}};

		//新开辟一个线程，该线程用于进行图片的下载
		//这个下载是一个异步的操作。我们无法等到线程完毕后来获取对象
		//所以需要一个机制：当下载完成后收到相应的通知。所以才有了handle
		new Thread(){
			@Override
			public void run() {
				super.run();
				//因为内部类访问外部变量所以参数imageUrl和imageCallback要有final修饰
				Drawable drawable=loadImageFromURL(imageUrl);
				imageCatch.put(imageUrl,new SoftReference&lt;Drawable&gt; (drawable));//下载后放到缓存里面
				Message message=new Message();
				message.obj=drawable;
				//因为内部类访问外部变量所以变量handle要有final修饰
				handler.sendMessage(message);
			}}.start();
		return null;//这里不能返回此drawable.
		           //因为这个下载是一个异步的过程,很可能执行到此return语句时图片还没有下载完！
	}
}

//接口实现类如下：
package cn.com;
import android.graphics.drawable.Drawable;
import android.widget.ImageView;
import cn.com.AsyncImageLoader.ImageCallback;
public class ImageCallbackImpl implements ImageCallback {
	private ImageView imageView;
	//构造方法
	public ImageCallbackImpl(ImageView imageView) {
		super();
		this.imageView = imageView;
	}
	@Override
	public void showLoadedImage(Drawable imageDrawable) {
	         imageView.setImageDrawable(imageDrawable);
	}

}
</pre>
<p> </p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 16:11:27</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/http/" title="http">http</a>, <a href="https://www.iamivan.net/tag/android/" title="android">android</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/%e7%ba%bf%e7%a8%8b/" title="线程">线程</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>利用SoftReference实现图片异步加载的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3jeL7z.html" rel="bookmark">Android-Universal-Image-Loader 图片异步加载类库的使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在博客中看到一篇利用组件进行图片异步加载的文章在此作记录 原文:http://blog.csdn.net/vipzjyno1/article/details/23206387 这个图片异步加载并缓存的类已经被很多开发者所使用,是最常用的几个开源库之一,主流的应用,随便反编译几个火的项目,都可以见到它的身影.        可是有的人并不知道如何去使用这库如何进行配置,网上查到的信息对于刚接触的人来说可能太少了,下面我就把我使用过程中所知道的写了下来,希望可以帮助自己和别人更深入了解这个库的使用和			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/My2Gv4p.html" rel="bookmark">Android优化双缓存的图片异步加载工具&lpar;LruCache&plus;SoftReference&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				之前在郭大神的博客看到使用LruCache算法实现图片缓存的.这里仿效他的思路,自己也写了一个. 并加入ConcurrentHashMap&lt;String, SoftReference&lt;Bitmap&gt;&gt;去实现二级缓存,因为ConcurrentHashMap是多个锁的线程安全,支持高并发.很适合这种频繁访问读取内存的操作. 下面整个思路是,使用了系统提供的LruCache类做一级缓存, 大小为运行内存的1/8,当LruCache容量要满的时候,会自动将系统移除的图片放到二级缓存中,但为			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MW27vqb.html" rel="bookmark">ios UITableView封装之下拉-上提-图片异步加载</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				写在前面 做过移动端开发的人都知道,列表控件是最常用的控件之一.iOS里的列表控件是UITableView,其实Apple的开发人员对于UITableView的设计已经够好的了(简单易用,扩展性非常强等等). 但对于展示逻辑单一的移动端系统软件,你还是能感觉到有些繁琐(或许是程序员天生就有些懒惰的毛病吧). 来看看它到底繁琐在哪儿了.首先,它的使用频率太高了:第二,它通常不是只呈现一下数据就完事了,一般都会跟随下拉刷新.上提加载更多功能,当然通常还要跟网络下载数据.图片打交道:第三,MVC模式是			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxonGGb.html" rel="bookmark">listview-Android ListView图片异步加载和上拉加载</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Android ListView图片异步加载和上拉加载 我的ListView设置一个OnScrollListener,然后更加可见的item数目来异步加载图片,和缓存图片, 但同时这个ListView又是个第三方的带上拉加载的,第三方的代码里也注册了OnScrollListener, 因此这两个OnScrollListener,只能有一个生效,但我想把上拉加载和异步加载图片的逻辑, 都写在同一个OnScrollListener,有什么好的设计吗? 问题在于上拉加载是在第三方的库中,而异			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M94K44b.html" rel="bookmark">Android-Universal-Image-Loader 图片异步加载类库的使用（超详细配置）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				       这个图片异步加载并缓存的类已经被很多开发者所使用,是最常用的几个开源库之一,主流的应用,随便反编译几个火的项目,都可以见到它的身影.        可是有的人并不知道如何去使用这库如何进行配置,网上查到的信息对于刚接触的人来说可能太少了,下面我就把我使用过程中所知道的写了下来,希望可以帮助自己和别人更深入了解这个库的使用和配置.          GITHUB上的下载路径为:https://github.com/nostra13/Android-Universal-Image-Lo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJAyAqp.html" rel="bookmark">Android-Universal-Image-Loader图片异步加载并缓存</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 这个图片异步加载并缓存的类已经被很多开发者所使用,是最常用的几个开源库之一,主流的应用,随便反编译几个火的项目,都可以见到它的身影.        可是有的人并不知道如何去使用这库如何进行配置,网上查到的信息对于刚接触的人来说可能太少了,下面我就把我使用过程中所知道的写了下来,希望可以帮助自己和别人更深入了解这个库的使用和配置.          GITHUB上的下载路径为:https://github.com/nostra13/Android-Universal-Image-Loader ,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bB1jo4z.html" rel="bookmark">Android图片异步加载框架Android-Universal-Image-Loader</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android-Universal-Image-Loader是一个图片异步加载,缓存和显示的框架.这个框架已经被很多开发者所使用,是最常用的几个Android开源项目之一,主流的应用,随便反编译几个,都可以见到它的身影.淘宝,天猫,Facebook,京东商城等都用到了这个项目.该项目的Github地址链接:https://github.com/nostra13/Android-Universal-Image-Loader 运行流程:每一个图片的加载和显示任务都运行在独立的线程中,除非这个图片缓存			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mqg522z.html" rel="bookmark">Android图片异步加载</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				开发Android程序,一般情况下都会有两个操作,图片的异步加载与缓存,而图片的异步加载大都是从网络读取图片(还有生成本地图片缩略图等操作),为了减少网络操作,加快图片加载速度就需要对图片进行缓存,所以网上的好多图片异步加载方法都是与图片的缓存紧密关联的.但也有可能用户已经有了缓存的相关类库,这样使用起来就会有点麻烦. 最近一段处理跟图片相关的问题,本来是自己写的图片加载,不过有些状态的控制还是比较烦人的,比如ListView滚动时ImageView的重用,所以本着偷懒与充分利用现有资源的态度去			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRqZYxb.html" rel="bookmark">android图片异步加载到本地</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				package com.example.health.util; import java.lang.ref.SoftReference; import java.util.HashMap; import java.util.HashSet; import java.util.Map; import java.util.concurrent.ExecutorService; import java.util.concurrent.Executors; import android.content.			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMAAVXM.html" rel="bookmark" class="title">PhotoShop设计制作梦幻炫彩光斑文字效果教程</a>
					<div>
						最终效果图: 1.选择&quot;文件/新建&quot;菜单,打开&quot;新建&quot;或者ctrl+n对话框 名称为:photoshop文字特效,宽度:为590像素, 高度:为500 2.在工 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp86Lob.html" rel="bookmark" class="title">使用&period;Net C&num;开发批量ACCESS数据库压缩软件</a>
					<div>
						第一次写使用.NET C# 开发了一个稍稍像样子的软件,在这个软件开发过程中我查了好多资料,也学到了很多小技巧 像FolderBrowserDialog(用于浏览选择文件夹的对话框).MessageB ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1Mvd0Az.html" rel="bookmark" class="title">掌握 ASP&period;NET 之路：自定义实体类简介</a>
					<div>
						asp.net 摘要:有些情况下,非类型化的 DataSet 可能并非数据操作的最佳解决方案.本指南的目的就是探讨 DataSet 的一种替代解决方案,即:自定义实体与集合.(本文包含一些指向英文站点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LpdZOAb.html" rel="bookmark" class="title">老淘客提醒新手淘客优化网站时应该注意的地方</a>
					<div>
						这是一个技术性很强的问题,很多人都不明白,也不愿意涉及这个方面,可以只要靠自己的努力和多看别人的文章才能弄懂,这样你会实现你的网站优化的效果.让你的淘宝店铺增加流量了.呵呵,还等什么,看看我给你们介绍 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMA9LvM.html" rel="bookmark" class="title">京东咚咚简介</a>
					<div>
						京东咚咚是京东商城发布的一款类似于阿里旺旺的个人IM软件,名为&quot;京东咚咚&quot;.从官网(dongdong.jd.com)介绍来看,京东咚咚主要有两部分功能,一是个人用户之间的沟通,可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLrDeb.html" rel="bookmark" class="title">Word 2007博客功能使用教程</a>
					<div>
						Word2007中集成了直接发布Blog的功能早已传得沸沸扬扬,很多用户还不大熟悉具体的操作流程.笔者认为,在博客大为盛行的今天,Word必然会对其产生很大的推动作用,这就使得不计其数的朋友不用再登陆 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPKZKz.html" rel="bookmark" class="title">在Word中也能&OpenCurlyDoubleQuote;听歌看碟&rdquo;</a>
					<div>
						Word也能&quot;听歌看碟&quot;!?没错!我们只要在Word中稍加设置, 就能让Word声色俱全.能说会唱.现在笔者就以播放一首MTV为例介绍操作方法 .(笔者使用的是Word2003,W ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2y99rz.html" rel="bookmark" class="title">Visual C&plus;&plus;剪贴板操作不完全攻略</a>
					<div>
						经常在论坛上见到一些使用者询问如何在Visual C++中如何实现对剪贴板的操作,其实在VC++/MFC中是相当简单的.本文主要介绍了如下内容: 1.文本内容的操作 2.WMF数据的操作 3.位图的操 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZOAGBb.html" rel="bookmark" class="title">JavaScript的20条常规建议</a>
					<div>
						  1. 用 === 代替 ==  JavaScript里有两种不同的相等运算符:===|!== 和==|!=.相比之下,前者更值得推荐.请尽量使用前者.  引用:  &quot;如果两个比较对象有着 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXBXOlb.html" rel="bookmark" class="title">WPS2016如何快速替换文字？</a>
					<div>
						  1.打开需要编辑修改的WPS文档 2.选中需要修改的文字内容,然后点击工具栏的&quot;查找替换&quot;然后选择&quot;替换&quot; 3.我们可以对&quot;查找内容&quot;进 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN1PZPb.html" rel="bookmark" class="title">如何为 Mac OS X 启用 Root 账户&quest;</a>
					<div>
						  尽管 Apple 不推荐开启 Mac OS X 的 Root 账户,但有时会遇到一些操作上的麻烦不得不开启 Root 账户来解决.那么怎么开启 Mac OS X 的 Root 账户呢? 开启 Ro ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDYNyBb.html" rel="bookmark" class="title">go语言base64用法实例&lowbar;Golang</a>
					<div>
						本文实例讲述了go语言base64用法.分享给大家供大家参考.具体如下: 这里展示golang base64 的一个小例子,代码如下: 复制代码 代码如下: package main import ( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NOoAM.html" rel="bookmark" class="title">基础01：比特、字节及进制</a>
					<div>
						位和字节及进制关系,是最基本的计算机基础知识,但实际使用中,是否真的理解清楚了? 比特和字节 Bit,比特,也叫二进制位,是信息的最小单位.一个比特可以理解为一个开关量,0就是关,1就是开. Byte ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKY9Aap.html" rel="bookmark" class="title">微步在线入选全球网络安全500强</a>
					<div>
						日前,全球领先的网络安全市场研究公司Cybersecurity Ventures发布了最新的全球网络安全企业500强(The Cybersecurity 500)名单,共有9家中国企业上榜,其中微步在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdRNGAb.html" rel="bookmark" class="title">c&plus;&plus;-C&plus;&plus;指针赋值问题，求帮助！</a>
					<div>
						问题描述 C++指针赋值问题,求帮助! int a=12; int b; int *p; int **ptr; p=&amp;a;//&amp;a的结果是一个指针,类型是int*,指向的类型是int, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDe1dXb.html" rel="bookmark" class="title">WEB2&period;0标准教程：第三天 定义</a>
					<div>
						第三步是定义你的语言编码:&lt;meta http-equiv=&quot;Content-Type&quot; content=&quot;text/html; charset=gb2312&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXB1Wz.html" rel="bookmark" class="title">西藏天路&OpenCurlyDoubleQuote;两庆&rdquo;玄机：150万吨铜矿的故事下回分解</a>
					<div>
						西藏天路新加入两名矿业背景高管.市场人士猜测,这是其进军转型重要信号,但该地区开矿难度有待观察 5月6日,西藏天路(600326.SH)第四届董事会审议通过了最终的高管名单.在这张名单里,有两个第一次 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M12E8ap.html" rel="bookmark" class="title">从网络音乐电台Pandora折射行业生存难题</a>
					<div>
						硅谷网讯 当音乐在网络上都播放了超过20年的时候, 数字音乐行业的一个根本问题始终没有解决:词曲作家和音乐人到底应该从音乐网站拿到 多少版权费?这个比率又该由谁决定? 最近,就在国内针对数字音乐还在为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M60GZAz.html" rel="bookmark" class="title">《机械制造业智能工厂规划设计》&mdash;&mdash;2&period;2　智能工厂设计需求分析</a>
					<div>
						2.2 智能工厂设计需求分析 我们在这里不讲战略规划的方法,假设企业已经通过战略分析制定了战略规划,但是在做智能工厂规划设计时,还要站在智能工厂的高度回顾和梳理战略分析,进行智能工厂的需求分析,制定智 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3JkJWz.html" rel="bookmark" class="title">Linux内核剖析 之 内存寻址（一）</a>
					<div>
						1.内存地址 逻辑地址(Logical Address):包含在机器语言中用来指定一个操作数或一条指令的地址.每个逻辑地址都由一个端(segment)和偏移量(offset或displacement) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M60VBAz.html" rel="bookmark" class="title">比亚迪、腾讯跻身&OpenCurlyDoubleQuote;全球科技百强&rdquo;三甲</a>
					<div>
						&lt;商业周刊&gt;近日公布&quot;2010年全球IT企业100强&quot;评选结果,深圳企业比亚迪超越苹果.亚马逊等IT业巨头夺得霸主地位:腾讯也从2009年该榜单的第七名跻身至第三,与位 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyearvM.html" rel="bookmark" class="title">C&num;正则急用，求解</a>
					<div>
						问题描述 怎么匹配网页中&lt;h2class=&quot;media-title&quot;&gt;迷你世界&lt;/h2&gt;这个标签,并取出迷你世界啊 解决方案 解决方案二:@&quot;&l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkA61M.html" rel="bookmark" class="title">大数据：应用跑到了科研前头</a>
					<div>
						在刚刚结束的&quot;2012年中国计算机大会&quot;上,&quot;大数据&quot;是出现频率最高的一个词,几乎每个主讲者.每场论坛都涉及这几个字.同时,中国计算机学会也在大会举行期间,正式 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJq5lVp.html" rel="bookmark" class="title">请教怎么让自己成长为有经验的程序员</a>
					<div>
						问题描述 我刚进入公司,没有项目经验,在公司感到很压抑.请教前辈们,怎么样让自己慢慢成熟起来 解决方案 解决方案二:最好的办法就是多参加项目实战,不用感到压抑,都是从那个阶段过来的,坚持一下就好了,加 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pX0Jmlp.html" rel="bookmark" class="title">涪陵高端榨菜一包2200元价格远高过飞天茅台</a>
					<div>
						胡笑红 一包600克的榨菜标价2200元,昨天有消息曝出中信公司最近发布研报,涪陵榨菜今年将要向市场投放一种高端榨菜产品.对于这一价格已超过53度飞天茅台的榨菜,有分析师认为:这更多的是一种噱头. 除 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1x2ob.html" rel="bookmark" class="title">jeecms</a>
					<div>
						问题描述 谁有jeecms系统的使用说明文档,给发一份,不胜感激邮箱:215811927@qq.com 解决方案 解决方案二:我没有					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKqg37p.html" rel="bookmark" class="title">SEO公司如何留住宝贵的人才资源</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 大家好,我是梁磊.随着SEO的火爆 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Qn87p.html" rel="bookmark" class="title">对Docker存储驱动的评价</a>
					<div>
						本文讲的是对Docker存储驱动的评价,[编者的话]Docker 的生态系统不断完善,上到容器的编排发布,下到网络存储,都有着各种选择.对于Docker 最底层的存储驱动,也有着Overlay.Zfs ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWNvdz.html" rel="bookmark" class="title">VS2010 提示输入注册码</a>
					<div>
						问题描述 VS2010旗舰版老是提示输入注册码,办公室4台电脑,其中有3台没问题,现在就1台频繁弹出输入注册码,网上百度了注册码,提示无效,然后继续弹出,随便输入或者输错注册码后,VS自动关闭,打开时 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlA2YLp.html" rel="bookmark" class="title">武汉iphone4s团购价还赠豪华礼</a>
					<div>
						第1页年末冲刺 武汉iphone4s团购价还赠豪华礼包 [天极网武汉站商家行情]&quot;核战争&quot;一触即发,近日朝鲜半岛局势陡然紧张,朝鲜宣布进行第三次核试验.手机数码领域也是&quot; ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
